Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 9019)
@@ -572,9 +548,9 @@
                ENDIF
 
-               IF( dta%ll_v2d .and. .not. ln_full_vel_array(ib_bdy) ) THEN
+               IF( dta%ll_v2d .and. .not. ln_full_vel_array(jbdy) ) THEN
                   if(lwp) write(numout,*) '++++++ reading in v2d field'
                   jfld = jfld + 1
                   blf_i(jfld) = bn_v2d
-                  ibdy(jfld) = ib_bdy
+                  ibdy(jfld) = jbdy
                   igrid(jfld) = 3
                   ilen1(jfld) = nblen(igrid(jfld))
@@ -587,27 +563,27 @@
             ! read 3D velocities if baroclinic velocities require OR if
             ! barotropic velocities required and ln_full_vel set to .true.
-            IF( nn_dyn3d_dta(ib_bdy) == 1 .OR. &
-           &  ( ln_full_vel_array(ib_bdy) .AND. ( nn_dyn2d_dta(ib_bdy) == 1 .or. nn_dyn2d_dta(ib_bdy) == 3 ) ) ) THEN
-
-               IF( dta%ll_u3d .OR. ( ln_full_vel_array(ib_bdy) .and. dta%ll_u2d ) ) THEN
+            IF( nn_dyn3d_dta(jbdy) == 1 .OR. &
+           &  ( ln_full_vel_array(jbdy) .AND. ( nn_dyn2d_dta(jbdy) == 1 .OR. nn_dyn2d_dta(jbdy) == 3 ) ) ) THEN
+
+               IF( dta%ll_u3d .OR. ( ln_full_vel_array(jbdy) .and. dta%ll_u2d ) ) THEN
                   if(lwp) write(numout,*) '++++++ reading in u3d field'
                   jfld = jfld + 1
                   blf_i(jfld) = bn_u3d
-                  ibdy(jfld) = ib_bdy
+                  ibdy(jfld) = jbdy
                   igrid(jfld) = 2
                   ilen1(jfld) = nblen(igrid(jfld))
                   ilen3(jfld) = jpk
-                  IF( ln_full_vel_array(ib_bdy) .and. dta%ll_u2d ) dta%nread(2) = dta%nread(2) + 1
-               ENDIF
-
-               IF( dta%ll_v3d .OR. ( ln_full_vel_array(ib_bdy) .and. dta%ll_v2d ) ) THEN
+                  IF( ln_full_vel_array(jbdy) .and. dta%ll_u2d ) dta%nread(2) = dta%nread(2) + 1
+               ENDIF
+
+               IF( dta%ll_v3d .OR. ( ln_full_vel_array(jbdy) .and. dta%ll_v2d ) ) THEN
                   if(lwp) write(numout,*) '++++++ reading in v3d field'
                   jfld = jfld + 1
                   blf_i(jfld) = bn_v3d
-                  ibdy(jfld) = ib_bdy
+                  ibdy(jfld) = jbdy
                   igrid(jfld) = 3
                   ilen1(jfld) = nblen(igrid(jfld))
                   ilen3(jfld) = jpk
-                  IF( ln_full_vel_array(ib_bdy) .and. dta%ll_v2d ) dta%nread(2) = dta%nread(2) + 1
+                  IF( ln_full_vel_array(jbdy) .and. dta%ll_v2d ) dta%nread(2) = dta%nread(2) + 1
                ENDIF
 
@@ -615,5 +591,5 @@
 
             ! temperature and salinity
-            IF( nn_tra_dta(ib_bdy) == 1 ) THEN
+            IF( nn_tra_dta(jbdy) == 1 ) THEN
 
                IF( dta%ll_tem ) THEN
@@ -621,5 +597,5 @@
                   jfld = jfld + 1
                   blf_i(jfld) = bn_tem
-                  ibdy(jfld) = ib_bdy
+                  ibdy(jfld) = jbdy
                   igrid(jfld) = 1
                   ilen1(jfld) = nblen(igrid(jfld))
@@ -631,5 +607,5 @@
                   jfld = jfld + 1
                   blf_i(jfld) = bn_sal
-                  ibdy(jfld) = ib_bdy
+                  ibdy(jfld) = jbdy
                   igrid(jfld) = 1
                   ilen1(jfld) = nblen(igrid(jfld))
@@ -639,40 +615,8 @@
             ENDIF
 
-#if defined key_lim2
+#if defined key_lim3
             ! sea ice
-            IF( nn_ice_lim_dta(ib_bdy) == 1 ) THEN
-
-               IF( dta%ll_frld ) THEN
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_frld
-                  ibdy(jfld) = ib_bdy
-                  igrid(jfld) = 1
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = 1
-               ENDIF
-
-               IF( dta%ll_hicif ) THEN
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_hicif
-                  ibdy(jfld) = ib_bdy
-                  igrid(jfld) = 1
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = 1
-               ENDIF
-
-               IF( dta%ll_hsnif ) THEN
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_hsnif
-                  ibdy(jfld) = ib_bdy
-                  igrid(jfld) = 1
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = 1
-               ENDIF
-
-            ENDIF
-#elif defined key_lim3
-            ! sea ice
-            IF( nn_ice_lim_dta(ib_bdy) == 1 ) THEN
-               ! Test for types of ice input (lim2 or lim3) 
+            IF( nn_ice_lim_dta(jbdy) == 1 ) THEN
+               ! Test for types of ice input (1cat or Xcat) 
                ! Build file name to find dimensions 
                clname=TRIM( cn_dir )//TRIM(bn_a_i%clname)
@@ -687,11 +631,11 @@
                !
                CALL iom_open  ( clname, inum )
-               id1 = iom_varid( inum, bn_a_i%clvar, kndims=zndims, ldstop = .FALSE. )
+               id1 = iom_varid( inum, bn_a_i%clvar, kdimsz=kdimsz, kndims=kndims, ldstop = .FALSE. )
                CALL iom_close ( inum )
 
-      	       IF ( zndims == 4 ) THEN
-                 ll_bdylim3 = .TRUE.   ! lim3 input
+      	       IF ( kndims == 4 ) THEN
+                 nice_cat = kdimsz(4)   ! Xcat input
                ELSE
-                 ll_bdylim3 = .FALSE.  ! lim2 input      
+                 nice_cat = 1           ! 1cat input      
                ENDIF
                ! End test
@@ -700,26 +644,26 @@
                   jfld = jfld + 1
                   blf_i(jfld) = bn_a_i
-                  ibdy(jfld) = ib_bdy
+                  ibdy(jfld)  = jbdy
                   igrid(jfld) = 1
                   ilen1(jfld) = nblen(igrid(jfld))
-                  IF ( ll_bdylim3 ) THEN ; ilen3(jfld)=jpl ; ELSE ; ilen3(jfld)=1 ; ENDIF
-               ENDIF
-
-               IF( dta%ll_ht_i ) THEN
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_ht_i
-                  ibdy(jfld) = ib_bdy
+                  ilen3(jfld) = nice_cat
+               ENDIF
+
+               IF( dta%ll_h_i ) THEN
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_h_i
+                  ibdy(jfld)  = jbdy
                   igrid(jfld) = 1
                   ilen1(jfld) = nblen(igrid(jfld))
-                  IF ( ll_bdylim3 ) THEN ; ilen3(jfld)=jpl ; ELSE ; ilen3(jfld)=1 ; ENDIF
-               ENDIF
-
-               IF( dta%ll_ht_s ) THEN
-                  jfld = jfld + 1
-                   blf_i(jfld) = bn_ht_s
-                  ibdy(jfld) = ib_bdy
+                  ilen3(jfld) = nice_cat
+               ENDIF
+
+               IF( dta%ll_h_s ) THEN
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_h_s
+                  ibdy(jfld)  = jbdy
                   igrid(jfld) = 1
                   ilen1(jfld) = nblen(igrid(jfld))
-                  IF ( ll_bdylim3 ) THEN ; ilen3(jfld)=jpl ; ELSE ; ilen3(jfld)=1 ; ENDIF
+                  ilen3(jfld) = nice_cat
                ENDIF
 
@@ -728,17 +672,17 @@
             ! Recalculate field counts
             !-------------------------
-            IF( ib_bdy == 1 ) THEN 
+            IF( jbdy == 1 ) THEN 
                nb_bdy_fld_sum = 0
-               nb_bdy_fld(ib_bdy) = jfld
+               nb_bdy_fld(jbdy) = jfld
                nb_bdy_fld_sum     = jfld              
             ELSE
-               nb_bdy_fld(ib_bdy) = jfld - nb_bdy_fld_sum
-               nb_bdy_fld_sum = nb_bdy_fld_sum + nb_bdy_fld(ib_bdy)
-            ENDIF
-
-            dta%nread(1) = nb_bdy_fld(ib_bdy)
+               nb_bdy_fld(jbdy) = jfld - nb_bdy_fld_sum
+               nb_bdy_fld_sum = nb_bdy_fld_sum + nb_bdy_fld(jbdy)
+            ENDIF
+
+            dta%nread(1) = nb_bdy_fld(jbdy)
 
          ENDIF ! nn_dta == 1
-      ENDDO ! ib_bdy
+      ENDDO ! jbdy
 
       DO jfld = 1, nb_bdy_fld_sum
@@ -752,7 +696,7 @@
       !-------------------------------------
       jstart = 1
-      DO ib_bdy = 1, nb_bdy
-         jend = jstart - 1 + nb_bdy_fld(ib_bdy) 
-         CALL fld_fill( bf(jstart:jend), blf_i(jstart:jend), cn_dir_array(ib_bdy), 'bdy_dta',   &
+      DO jbdy = 1, nb_bdy
+         jend = jstart - 1 + nb_bdy_fld(jbdy) 
+         CALL fld_fill( bf(jstart:jend), blf_i(jstart:jend), cn_dir_array(jbdy), 'bdy_dta',   &
          &              'open boundary conditions', 'nambdy_dta' )
          jstart = jend + 1
@@ -765,8 +709,8 @@
 
       jfld = 0
-      DO ib_bdy=1, nb_bdy
-
-         nblen => idx_bdy(ib_bdy)%nblen
-         dta => dta_bdy(ib_bdy)
+      DO jbdy=1, nb_bdy
+
+         nblen => idx_bdy(jbdy)%nblen
+         dta => dta_bdy(jbdy)
 
          if(lwp) then
@@ -780,5 +724,5 @@
          endif
 
-         IF ( nn_dyn2d_dta(ib_bdy) == 0 .or. nn_dyn2d_dta(ib_bdy) == 2 ) THEN
+         IF ( nn_dyn2d_dta(jbdy) == 0 .or. nn_dyn2d_dta(jbdy) == 2 ) THEN
             if(lwp) write(numout,*) '++++++ dta%ssh/u2d/u3d allocated space'
             IF( dta%ll_ssh ) ALLOCATE( dta%ssh(nblen(1)) )
@@ -786,5 +730,5 @@
             IF( dta%ll_v2d ) ALLOCATE( dta%v2d(nblen(3)) )
          ENDIF
-         IF ( nn_dyn2d_dta(ib_bdy) == 1 .or. nn_dyn2d_dta(ib_bdy) == 3 ) THEN
+         IF ( nn_dyn2d_dta(jbdy) == 1 .or. nn_dyn2d_dta(jbdy) == 3 ) THEN
             IF( dta%ll_ssh ) THEN
                if(lwp) write(numout,*) '++++++ dta%ssh pointing to fnow'
@@ -793,5 +737,5 @@
             ENDIF
             IF ( dta%ll_u2d ) THEN
-               IF ( ln_full_vel_array(ib_bdy) ) THEN
+               IF ( ln_full_vel_array(jbdy) ) THEN
                   if(lwp) write(numout,*) '++++++ dta%u2d allocated space'
                   ALLOCATE( dta%u2d(nblen(2)) )
@@ -803,5 +747,5 @@
             ENDIF
             IF ( dta%ll_v2d ) THEN
-               IF ( ln_full_vel_array(ib_bdy) ) THEN
+               IF ( ln_full_vel_array(jbdy) ) THEN
                   if(lwp) write(numout,*) '++++++ dta%v2d allocated space'
                   ALLOCATE( dta%v2d(nblen(3)) )
@@ -814,80 +758,65 @@
          ENDIF
 
-         IF ( nn_dyn3d_dta(ib_bdy) == 0 ) THEN
+         IF ( nn_dyn3d_dta(jbdy) == 0 ) THEN
             if(lwp) write(numout,*) '++++++ dta%u3d/v3d allocated space'
-            IF( dta%ll_u3d ) ALLOCATE( dta_bdy(ib_bdy)%u3d(nblen(2),jpk) )
-            IF( dta%ll_v3d ) ALLOCATE( dta_bdy(ib_bdy)%v3d(nblen(3),jpk) )
-         ENDIF
-         IF ( nn_dyn3d_dta(ib_bdy) == 1 .or. &
-           &  ( ln_full_vel_array(ib_bdy) .and. ( nn_dyn2d_dta(ib_bdy) == 1 .or. nn_dyn2d_dta(ib_bdy) == 3 ) ) ) THEN
-            IF ( dta%ll_u3d .or. ( ln_full_vel_array(ib_bdy) .and. dta%ll_u2d ) ) THEN
+            IF( dta%ll_u3d ) ALLOCATE( dta_bdy(jbdy)%u3d(nblen(2),jpk) )
+            IF( dta%ll_v3d ) ALLOCATE( dta_bdy(jbdy)%v3d(nblen(3),jpk) )
+         ENDIF
+         IF ( nn_dyn3d_dta(jbdy) == 1 .or. &
+           &  ( ln_full_vel_array(jbdy) .and. ( nn_dyn2d_dta(jbdy) == 1 .or. nn_dyn2d_dta(jbdy) == 3 ) ) ) THEN
+            IF ( dta%ll_u3d .or. ( ln_full_vel_array(jbdy) .and. dta%ll_u2d ) ) THEN
                if(lwp) write(numout,*) '++++++ dta%u3d pointing to fnow'
                jfld = jfld + 1
-               dta_bdy(ib_bdy)%u3d => bf(jfld)%fnow(:,1,:)
-            ENDIF
-            IF ( dta%ll_v3d .or. ( ln_full_vel_array(ib_bdy) .and. dta%ll_v2d ) ) THEN
+               dta_bdy(jbdy)%u3d => bf(jfld)%fnow(:,1,:)
+            ENDIF
+            IF ( dta%ll_v3d .or. ( ln_full_vel_array(jbdy) .and. dta%ll_v2d ) ) THEN
                if(lwp) write(numout,*) '++++++ dta%v3d pointing to fnow'
                jfld = jfld + 1
-               dta_bdy(ib_bdy)%v3d => bf(jfld)%fnow(:,1,:)
-            ENDIF
-         ENDIF
-
-         IF( nn_tra_dta(ib_bdy) == 0 ) THEN
+               dta_bdy(jbdy)%v3d => bf(jfld)%fnow(:,1,:)
+            ENDIF
+         ENDIF
+
+         IF( nn_tra_dta(jbdy) == 0 ) THEN
             if(lwp) write(numout,*) '++++++ dta%tem/sal allocated space'
-            IF( dta%ll_tem ) ALLOCATE( dta_bdy(ib_bdy)%tem(nblen(1),jpk) )
-            IF( dta%ll_sal ) ALLOCATE( dta_bdy(ib_bdy)%sal(nblen(1),jpk) )
+            IF( dta%ll_tem ) ALLOCATE( dta_bdy(jbdy)%tem(nblen(1),jpk) )
+            IF( dta%ll_sal ) ALLOCATE( dta_bdy(jbdy)%sal(nblen(1),jpk) )
          ELSE
             IF( dta%ll_tem ) THEN
                if(lwp) write(numout,*) '++++++ dta%tem pointing to fnow'
                jfld = jfld + 1
-               dta_bdy(ib_bdy)%tem => bf(jfld)%fnow(:,1,:)
+               dta_bdy(jbdy)%tem => bf(jfld)%fnow(:,1,:)
             ENDIF
             IF( dta%ll_sal ) THEN 
                if(lwp) write(numout,*) '++++++ dta%sal pointing to fnow'
                jfld = jfld + 1
-               dta_bdy(ib_bdy)%sal => bf(jfld)%fnow(:,1,:)
-            ENDIF
-         ENDIF
-
-#if defined key_lim2
-         IF (cn_ice_lim(ib_bdy) /= 'none') THEN
-            IF( nn_ice_lim_dta(ib_bdy) == 0 ) THEN
-               ALLOCATE( dta_bdy(ib_bdy)%frld(nblen(1)) )
-               ALLOCATE( dta_bdy(ib_bdy)%hicif(nblen(1)) )
-               ALLOCATE( dta_bdy(ib_bdy)%hsnif(nblen(1)) )
+               dta_bdy(jbdy)%sal => bf(jfld)%fnow(:,1,:)
+            ENDIF
+         ENDIF
+
+#if defined key_lim3
+         IF (cn_ice_lim(jbdy) /= 'none') THEN
+            IF( nn_ice_lim_dta(jbdy) == 0 ) THEN
+               ALLOCATE( dta_bdy(jbdy)%a_i(nblen(1),jpl) )
+               ALLOCATE( dta_bdy(jbdy)%h_i(nblen(1),jpl) )
+               ALLOCATE( dta_bdy(jbdy)%h_s(nblen(1),jpl) )
             ELSE
-               jfld = jfld + 1
-               dta_bdy(ib_bdy)%frld  => bf(jfld)%fnow(:,1,1)
-               jfld = jfld + 1
-               dta_bdy(ib_bdy)%hicif => bf(jfld)%fnow(:,1,1)
-               jfld = jfld + 1
-               dta_bdy(ib_bdy)%hsnif => bf(jfld)%fnow(:,1,1)
-            ENDIF
-         ENDIF
-#elif defined key_lim3
-         IF (cn_ice_lim(ib_bdy) /= 'none') THEN
-            IF( nn_ice_lim_dta(ib_bdy) == 0 ) THEN
-               ALLOCATE( dta_bdy(ib_bdy)%a_i (nblen(1),jpl) )
-               ALLOCATE( dta_bdy(ib_bdy)%ht_i(nblen(1),jpl) )
-               ALLOCATE( dta_bdy(ib_bdy)%ht_s(nblen(1),jpl) )
-            ELSE
-               IF ( ll_bdylim3 ) THEN ! case input is lim3 type
-                  jfld = jfld + 1
-                  dta_bdy(ib_bdy)%a_i  => bf(jfld)%fnow(:,1,:)
-                  jfld = jfld + 1
-                  dta_bdy(ib_bdy)%ht_i => bf(jfld)%fnow(:,1,:)
-                  jfld = jfld + 1
-                  dta_bdy(ib_bdy)%ht_s => bf(jfld)%fnow(:,1,:)
-               ELSE ! case input is lim2 type
+               IF ( nice_cat == jpl ) THEN ! case input cat = jpl
+                  jfld = jfld + 1
+                  dta_bdy(jbdy)%a_i => bf(jfld)%fnow(:,1,:)
+                  jfld = jfld + 1
+                  dta_bdy(jbdy)%h_i => bf(jfld)%fnow(:,1,:)
+                  jfld = jfld + 1
+                  dta_bdy(jbdy)%h_s => bf(jfld)%fnow(:,1,:)
+               ELSE                        ! case input cat = 1 OR (/=1 and /=jpl)
                   jfld_ai  = jfld + 1
                   jfld_hti = jfld + 2
                   jfld_hts = jfld + 3
                   jfld     = jfld + 3
-                  ALLOCATE( dta_bdy(ib_bdy)%a_i (nblen(1),jpl) )
-                  ALLOCATE( dta_bdy(ib_bdy)%ht_i(nblen(1),jpl) )
-                  ALLOCATE( dta_bdy(ib_bdy)%ht_s(nblen(1),jpl) )
-                  dta_bdy(ib_bdy)%a_i (:,:) = 0._wp
-                  dta_bdy(ib_bdy)%ht_i(:,:) = 0._wp
-                  dta_bdy(ib_bdy)%ht_s(:,:) = 0._wp
+                  ALLOCATE( dta_bdy(jbdy)%a_i(nblen(1),jpl) )
+                  ALLOCATE( dta_bdy(jbdy)%h_i(nblen(1),jpl) )
+                  ALLOCATE( dta_bdy(jbdy)%h_s(nblen(1),jpl) )
+                  dta_bdy(jbdy)%a_i(:,:) = 0._wp
+                  dta_bdy(jbdy)%h_i(:,:) = 0._wp
+                  dta_bdy(jbdy)%h_s(:,:) = 0._wp
                ENDIF
 
@@ -896,5 +825,5 @@
 #endif
          !
-      END DO ! ib_bdy 
+      END DO ! jbdy 
       !
       IF( nn_timing == 1 ) CALL timing_stop('bdy_dta_init')
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn2d.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn2d.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn2d.F90	(revision 9019)
@@ -249,6 +249,4 @@
       !  
       CALL bdy_orlanski_2d( idx, igrd, pvb2d, pva2d, dta%v2d, ll_npo )
-      !
-      IF( nn_timing == 1 ) CALL timing_stop('bdy_dyn2d_orlanski')
       !
       CALL lbc_bdy_lnk( pua2d, 'U', -1., ib_bdy )   ! Boundary points should be updated
